% Program 3.1. Approximation of the derivative of
% discontinuous functions

% Plot exp(-t)u(t)
% Derivative of exp(-t)u(t) is delta(t)-exp(-t)u(t)
% Plot the integrals of delta(t), -exp(-t)u(t)
% and delta(t)-exp(-t)
% Approximate the impulse by the
% exponential ae^(-at)u(t) with  a=100. 

clear; % clear variables and functions from memory

for inc=[0.001 0.0005 0.0001]
  clf; % clear current figure
  t=-0.1:inc:1; % time base values
  x2=t*0;xi=x2;x1=x2;x3=x2;
  k=2;
  for l=-0.1+inc:inc:1
    if (l>=0)
      x1(k)=exp(-l); % samples of the exponential
      x2(k)=x2(k-1)+inc*(-exp(-l)); % samples of the integral of -exp(-l)u(l)
      xi(k)=xi(k-1)+inc*100*exp(-100*l); % samples of the integral of the impulse
      x3(k)=x2(k)+xi(k); % samples of the exponential from the integral of its derivative
    end
    k=k+1;
  end
  plot(t,x1,t,x2,'-.',t,x3,':',t,xi,'--') % plot 
  ylabel('x(t)') % y-axis label of the graph is x(t)
  xlabel('t') % x-axis label of the graph is t
  title(['approximation of the derivative of exponential e^{-t}u(t), tinc=',num2str(inc)])
  legend('e^{-t}u(t)','\int -e^{-t}u(t)dt','\int(\delta(t)-e^{-t}u(t))dt','\int\delta(t)dt')
  axis([-0.1 1 -0.65 1.09])
  disp('see the plot and press any key to continue')
  pause % wait until a key is pressed
end

% Exercise. Approximate the impulse by 100(u(t)-u(t-0.01)).