% Program 3.3. Approximation of the impulse by the sinc function

% Plot the sinc function 
% sin(a*t)/(pi*t) for a=200*pi, a=300*pi, and a=400*pi.
% Display the area enclosed.

clear; % clear variables and functions from memory

T=0.1; %time base limit
N=1024; % number of samples
th=linspace(0,T,N);th(1)=1e-12; % half time base values
tinc=th(2);
t=[-fliplr(th(2:N)) th]; % time base values
for a=200*pi:100*pi:400*pi
  clf; % clear current figure
  xh=sin(a*th)./(pi*th); % positive half samples of the sinc function
  x=[fliplr(xh(2:N)) xh]; % samples of the sinc function
  s=tinc*sum(x); % area enclosed by the sinc function
  plot(t,x) % plot with solid line
  ylabel('\delta(t)') % y-axis label of the graph is delta(t)
  xlabel('t') % x-axis label of the graph is t
  text(0.7,0.75,['area=',num2str(s)],'units','normalized','fontsize',10);
  axis([-T T min(x) max(x)])
  title(['approximation of the impulse by the sinc function, sin(',num2str(a),'t)/(\pi t)'])
  disp('see the graph and press any key to continue')
  pause % wait until a key is pressed
end

% Exercise. Approximate the impulse by (u(t+a)-u(t-a))/(2a) for
% a=0.01, a=0.005, and a=0.001.
