% Program 3.4. Sampling property of the impulse.

% Approximate the impulse by the exponential
% ae^(-at)u(t) for a=100. 
% Plot the sinusoid cos(pi t).
% Plot the integral of the product of shifted impulse with cos(pi t).

clear; % clear variables and functions from memory
clf; % clear current figure

tinc=0.00001; % time increment
T=1; % time base limit
for t0=[-0.5 0 1/3] % sampling instant
  k=1;
  imp=(-T:tinc:T)*0;
  for t=-T:tinc:T
    if ((t-t0) >=0 )
      imp(k)=100*exp(-100*(t-t0)); %  approximation of the impulse by the exponential
    end
    k=k+1;
  end
  t=-T:tinc:T; % time base values
  x=cos(pi*t); % samples of the cosine wave
  samp=tinc * sum(x .* imp); %numerical integration of the product of
  % cosine wave and the impulse
  plot(t,x) % plot with solid line
  hold on
  plot(t0,samp,'*')
  ylabel('x(t)') % y-axis label of the graph is x(t)
  xlabel('t') % x-axis label of the graph is t
  text(t0,samp,['   t = ',num2str(t0)],'fontsize',8);
  legend('cosine wave', 'sample')
  title('sampling property of the impulse. cos(\pit) and its sampled values at t= -0.5,0,1/3')
  disp('see the graph and press any key to continue')
  pause % wait until a key is pressed
end

% Exercise. Approximate the impulse by 500(u(t+0.001)-u(t+0.001)).
