% Program 3.5. % Scaling property of the impulse.

% Approximation of the impulse by the exponential
% be^(-bt)u(t) with b=100 and the scale factor a.
% Plot the exponential be^(-bt)u(t) for  b=100. 
% Plot the exponential be^(-b(at))u(at) for  b=100. 
% Plot the exponential be^(-bt)u(t)/abs(a) for  b=100. 
% Show the respective areas enclosed

clear; % clear variables and functions from memory
clf; % clear current figure

tinc=0.0001; % time increment
for a=[-0.5 0.5 2 -1] % scale factors 
  p=1;
  x1=(-0.1:tinc:0.1)*0;x2=x1;x3=x1;
  for t=-0.1:tinc:0.1
    if ((a/abs(a))*t>0)
      x2(p)=100*exp(-100*(a*t)); % samples of the scaled impulse
    end
    if(t>0)
      x1(p)=100*exp(-100*t); % samples of the impulse
      x3(p)=(100/abs(a))*exp(-100*t); % samples of the scaled impulse using the property
    end
    p=p+1;
  end
  t=-0.1:tinc:0.1; % time base values
  plot(t,x1,t,x2,'--',t,x3,':') % plot with solid, dashed, and dotted lines
  ylabel('\delta(t)') % y-axis label of the graph is x(t)
  xlabel('t') % x-axis label of the graph is t
  s1=tinc*sum(x1); % area enclosed by the impulse
  s2=tinc*sum(x2); % area enclosed by the scaled impulse
  s3=tinc*sum(x3); % area enclosed by the scaled impulse using the property
  legend('\delta(t)',['\delta(',num2str(a),'t)'],['\delta(t) / ',num2str(abs(a))])
  title('Scaling property of the impulse')
  text(0.7,0.25,['\int\delta(',num2str(a),'t)dt = ',num2str(s2)],'units','normalized','fontsize',8);
  text(0.7,0.3,['\int\delta(t)dt = ',num2str(s1)],'units','normalized','fontsize',8);
  text(0.7,0.2,['\int(\delta(t) / ',num2str(abs(a)),')dt = ',num2str(s3)],'units','normalized','fontsize',8);
  axis([-0.1 0.1 min([min(x1),min(x2),min(x3)]) max([max(x1),max(x2),max(x3)])])
  disp('see the plot and press any key to continue')
  pause % wait until a key is pressed
end

% Exercise. Approximate the impulse by 100(u(t)-u(t-0.01)).