% Program 3.6. Approximation of the unit-step u(t)
 
% Plot the approximation of the unit-step function u(t) using
% the integral of the impulse, approximated by the
% triangle x(t)=t*(u(t)-u(t+2*a))/(2*a*a)
% for a=1, a=0.5, a=0.25, and a=0.1. 

clear; % clear variables and functions from memory
clf; % clear current figure

N=2048; % number of samples
for a=[1 0.5 0.25 0.1]
  t=linspace(-2*a-0.1*a,1,N); % time base values
  tinc=t(2)-t(1); % time increment
  m=1;
  imp=t*0;
  for k=t
     if ((k>=-2*a) && (k<=0))
        imp(m)=-k/(2*a*a); % samples of the impulse
     end
     m=m+1;
  end
  ustep=tinc*cumsum(imp);% numerical integration of the area of impulse
   
  subplot(2,1,1)
  plot(t,imp) % plot with solid line
  ylabel('\delta(t)') % y-axis label of the graph is delta(t)
  xlabel('t') % x-axis label of the graph is t
  text(-2*a,0.15*a+1/a,['a = ',num2str(a)],'fontsize',8);
  title('approximation of the impulse')
  text(0.05,0.7,'\delta(t) = a\rightarrow 0 (t/2a^{2})(u(t)-u(t+2a))','units','normalized','fontsize',12);
  axis([-2.1 1.1 0 10.4])
  hold on
   
  subplot(2,1,2)
  plot(t,ustep) % plot with solid line
  ylabel('u(t)') % y-axis label of the graph is u(t)
  xlabel('t') % x-axis label of the graph is t
  title('approximation of the unit-step')
  axis([-2.1 1 0 1.05])
  hold on
  text(0.7,0.3,'u(t) = \int_{-\infty}^{t}\delta(\tau)d\tau','units','normalized','fontsize',12);
  disp('see the plot and press any key to continue')
  pause % wait until a key is pressed
end

% Exercise. Use x(t)=(u(t)-u(t-a))/a to approximate the impulse.