% Program 3.9. Power of a signal  

% Plot the power of a sinusoid with varying
% amplitude, phase, and frequency. 

clear; % clear variables and functions from memory
clf; % clear current figure

ts=0.0001;
A=[1 2 3];w=[1 2 3];theta=[0 0.5 1];T=2*pi./w;
subplot(3,1,1)
powa=A*0;
for k=1:3 % varying amplitude
   t=0:ts:T(1)-ts/2;
   xa=A(k)*cos(w(1)*t+theta(1));
   powa(k)=ts*sum(xa.*xa)/T(1);
end
plot(1:3,powa,'*') % plot with * symbol
ylabel('powa') 
xlabel('A') 
set(gca,'YTick',powa)
axis([0.9 3.1 0.4 4.6])
legend('power v amplitude \omega=1,\theta=0')
title('power of a sinusoid A cos(\omegat+\theta) depends only on its amplitude, P=A*A/2')

subplot(3,1,2)
powf=w*0;
for k=1:3 %varying frequency
   t=0:ts:T(k)-ts/2;
   xb=A(1)*cos(w(k)*t+theta(1));
   powf(k)=ts*sum(xb.*xb)/T(k);
end
plot(1:3,powf,'*') % plot with * symbol
ylabel('powf') 
xlabel('\omega') 
axis([0.9 3.1 0.45 0.6])
legend('power v frequency A=1,\theta=0')

subplot(3,1,3)
powp=theta*0;
for k=1:3 %varying phase
   t=0:ts:T(1)-ts/2;
   xc=A(1)*cos(w(1)*t+theta(k));
   powp(k)=ts*sum(xc.*xc)/T(1);
end
plot(theta,powp,'*') % plot with * symbol
ylabel('powp') 
xlabel('phase in radians') 
axis([-0.1 1.2 0.45 0.6])
legend('power v phase, A=1,\omega=1')

% Exercise. Find the power of x(t)=3*exp(jt).
